/* tr_lpfind - find parent of node matching a specified key
 * iterative version
 * never returns NULL; may return addr of null ptr
 */
#include "tree.h"
static TR_NODE *nullp = NULL;	/* used to return addr of null ptr */
TR_NODE **tr_lpfind(plt, pn, cmpfn)
	TR_NODE **plt;			/* ptr to link-in of tree or subtree */
	TR_NODE *pn;			/* ptr to structure containing key to match */
	int (*cmpfn)();			/* ptr to comparison function */
	{
	TR_NODE *pt;			/* ptr to current tree */
	TR_NODE **plp;			/* ptr to link-in of parent of tree */
	int cmp;				/* comparison result: neg, zero, pos */

	plp = &nullp;					/* root has no parent */
	FOREVER
		{
		pt = *plt;					/* pt now points to current tree */
		if (pt == NULL)				/* if plt points to a null pointer, */
			return (&nullp);		/* the data isn't in the tree */
		else if ((cmp = (*cmpfn)(pn, pt)) == 0) /* if key already in tree, */
			return (plp);			/* return its parent's link-in */
		plp = plt;				/* before starting subtree, save plt */
		if (cmp < 0)				/* if key compares low, */
			plt = &pt->left;		/* then search in left tree */
		else						/* otherwise, */
			plt = &pt->right;	/* search in right tree */
		}
	}
